diff -ur slackware64-current.2/source/d/gcc/gcc.SlackBuild slackware64-current.3/source/d/gcc/gcc.SlackBuild
--- slackware64-current.2/source/d/gcc/gcc.SlackBuild	2023-05-05 22:30:32.537922890 +0200
+++ slackware64-current.3/source/d/gcc/gcc.SlackBuild	2023-05-09 11:39:32.890163735 +0200
@@ -88,6 +88,9 @@
   exit 0
 fi
 
+addlang="ada,d,go,"
+ENABLE_GC="--enable-objc-gc"
+
 if [ "$ARCH" = "i386" ]; then
   SLKCFLAGS="-O2 -march=i386 -mcpu=i686"
   LIBDIRSUFFIX=""
@@ -166,6 +169,17 @@
   fi
 done
 
+if [[ "$ARCH" = "arm" ]]
+then
+  # Ada tools now requires 64 bits atomic operation, need to link atomic library for arm:
+  zcat $CWD/patches/gcc.ada.atomic.armdiff.gz | patch -p1 --verbose || exit 1
+fi
+
+# Disabling c++ double128 compatibility on PowerPC platform
+#sed -i  's/powerpc\*-\*-linux\*/xpowerpc/' libstdc++-v3/configure
+# Disabling c++ double128 compatibility on Sparc(32bit) platform
+#sed -i  's/sparc\*-\*-linux\*/sparc64-*-linux*/' gcc-$VERSION/libstdc++-v3/configure
+
 # Fix perms/owners:
 chown -R root:root .
 find . \
@@ -343,7 +353,23 @@
   # Correct me if my take on this is wrong.
   #  --with-cpu=$ARCH 
  
-  if [ "$ARCH" != "x86_64" ]; then
+  if [ "$ARCH" == "armv7hl" ]; then
+    GCC_ARCHOPTS="--with-tune=cortex-a8 --with-arch=armv7-a --with-float=hard --with-fpu=vfpv3-d16 --with-abi=aapcs-linux"
+  elif [ "$ARCH" == "arm" ]; then
+    GCC_ARCHOPTS="--with-arch=armv5te --with-float=soft"
+  elif [ "$ARCH" == "aarch64" ]; then
+    GCC_ARCHOPTS="--with-arch=armv8-a"
+  elif [ "$ARCH" == "mips" ]; then
+    GCC_ARCHOPTS="--with-arch=mips32r2"
+  elif [ "$ARCH" == "mipsel" ]; then
+    GCC_ARCHOPTS="--with-arch=mips32r2"
+  elif [ "$ARCH" == "mips64el" ]; then
+    GCC_ARCHOPTS="--with-arch=mips64r2 --disable-multilib"
+  elif [ "$ARCH" == "sparc" ]; then
+    GCC_ARCHOPTS="--with-cpu=leon3 --with-float=hard --disable-multilib --disable-libitm"
+  elif [ "$ARCH" == "sparc64" ]; then
+    GCC_ARCHOPTS="--with-cpu=ultrasparc --with-float=hard --disable-multilib"
+  elif [ `echo "$ARCH" | grep -cE '^i.86$'` -gt 0 ]; then
     GCC_ARCHOPTS="--with-arch=$ARCH"
   else
     GCC_ARCHOPTS="--disable-multilib"
@@ -350,8 +390,10 @@
     GCC_ARCHOPTS="--disable-multilib"
   fi
  
-  CFLAGS="$SLKCFLAGS" \
-  CXXFLAGS="$SLKCFLAGS" \
+  CFLAGS="$SLKCFLAGS -D_DONOTFORCE_TIME_BITS" \
+  CXXFLAGS="$SLKCFLAGS -D_DONOTFORCE_TIME_BITS" \
+  LDFLAGS="-Wl,--no-keep-memory -Wl,--reduce-memory-overheads" \
+  BOOT_LDFLAGS="-Wl,--no-keep-memory -Wl,--reduce-memory-overheads" \
   ../configure --prefix=/usr \
      --libdir=/usr/lib$LIBDIRSUFFIX \
      --mandir=/usr/man \
@@ -368,10 +400,10 @@
      --infodir=/usr/info \
      --enable-shared \
      --enable-bootstrap \
-     --enable-languages=ada,c,c++,d,fortran,go,lto,m2,objc,obj-c++ \
+     --enable-languages=${addlang}c,c++,fortran,lto,m2,objc,obj-c++ \
      --enable-threads=posix \
      --enable-checking=release \
-     --enable-objc-gc \
+     $ENABLE_GC \
      --with-system-zlib \
      --enable-libstdcxx-dual-abi \
      --with-default-libstdcxx-abi=new \
@@ -377,6 +413,7 @@
   # Include all debugging info (for now):
   make $NUMJOBS bootstrap || exit 1
 
+  if [ `echo $addlang | grep -c 'ada,'` -gt 0 ] ; then
   ( cd gcc
     make $NUMJOBS gnatlib GNATLIBCFLAGS="$SLKCFLAGS" || exit 1
     # This wants a shared -ladd2line?
@@ -386,6 +423,7 @@
     CXXFLAGS="$SLKCFLAGS" \
     make $NUMJOBS gnattools || exit 1
   ) || exit 1
+  fi
   make info || exit 1
 
   # Set GCCCHECK=something to run the tests
@@ -395,6 +433,11 @@
 
   make install DESTDIR=$PKG1 || exit 1
 
+  if [ -d "$PKG1/usr/lib$LIBDIRSUFFIX/"'!m4' ]
+  then
+    (cd "$PKG1/usr/lib$LIBDIRSUFFIX/"'!m4' ; mv * .. ; cd .. ; rmdir '!m4')
+  fi
+
   # Move gdb pretty printers to the correct place
   mkdir -p $PKG1/usr/share/gdb/auto-load/usr/lib$LIBDIRSUFFIX
   mv $PKG1/usr/lib$LIBDIRSUFFIX/*-gdb.py \
@@ -406,7 +449,7 @@
   fi
 
   # Make our 64bit gcc look for 32bit gcc binaries in ./32 subdirectory:
-  if [ "$ARCH" = "x86_64" ]; then
+  if [ "$LIBDIRSUFFIX" = "64" ]; then
     sed -i 's#;.\(:../lib !m64 m32;\)$#;32\1#' \
       $PKG1/usr/lib${LIBDIRSUFFIX}/gcc/${TARGET}/${VERSION}/specs
   fi
@@ -490,6 +533,15 @@
     cat $CWD/c89.sh > c89
     cat $CWD/c99.sh > c99
     chmod 755 c89 c99
+    if [ "$TARGET" != "${ARCH}-slackware-linux" ]
+    then
+      for b in gm2 c++ g++ cc gcc gcc-ar gcc-nm gcc-ranlib gccgo gdc gfortran
+      do
+	if [ -f $b ]; then
+     	  ln -s $b ${ARCH}-slackware-linux-$b
+	fi
+      done
+    fi
   )
 
   ( cd $PKG1/usr/man
@@ -512,7 +555,7 @@
   mv $PKG1/usr/share/gdb usr/share
   mkdir -p usr/share/gcc-$VERSION/python
   mv $PKG1/usr/share/gcc-$VERSION/python/libstdcxx usr/share/gcc-$VERSION/python
-)
+) || exit 1
 
 # gcc-gfortran:
 ( cd $PKG3
@@ -534,8 +577,9 @@
   mv $PKG1/usr/libexec/gcc/$TARGET/$VERSION/libgfortran* usr/libexec/gcc/$TARGET/$VERSION
   mkdir -p usr/man/man1
   mv $PKG1/usr/man/man1/gfortran* usr/man/man1
-)
+) || exit 1
 
+if [ `echo $addlang | grep -c 'ada,'` -gt 0 ] ; then
 # gcc-gnat:
 ( cd $PKG4
   mkdir -p usr/bin
@@ -548,7 +592,8 @@
   mkdir -p usr/lib${LIBDIRSUFFIX}/gcc/$TARGET/$VERSION
   mv $PKG1/usr/lib${LIBDIRSUFFIX}/gcc/$TARGET/$VERSION/adainclude usr/lib${LIBDIRSUFFIX}/gcc/$TARGET/$VERSION
   mv $PKG1/usr/lib${LIBDIRSUFFIX}/gcc/$TARGET/$VERSION/adalib usr/lib${LIBDIRSUFFIX}/gcc/$TARGET/$VERSION
-)
+) || exit 1
+fi
 
 # gcc-objc:
 ( cd $PKG6
@@ -558,9 +603,9 @@
   mv $PKG1/usr/libexec/gcc/$TARGET/$VERSION/cc1obj usr/libexec/gcc/$TARGET/$VERSION
   mv $PKG1/usr/libexec/gcc/$TARGET/$VERSION/cc1objplus usr/libexec/gcc/$TARGET/$VERSION
   mkdir -p usr/lib${LIBDIRSUFFIX}/gcc/$TARGET/$VERSION/include
-  mv $PKG1/usr/lib${LIBDIRSUFFIX}/gcc/$TARGET/$VERSION/include/objc usr/lib${LIBDIRSUFFIX}/gcc/$TARGET/$VERSION/include
   mv $PKG1/usr/lib${LIBDIRSUFFIX}/gcc/$TARGET/$VERSION/include/cc1objplus usr/lib${LIBDIRSUFFIX}/gcc/$TARGET/$VERSION/include
-)
+  mv $PKG1/usr/lib${LIBDIRSUFFIX}/gcc/$TARGET/$VERSION/include/objc usr/lib${LIBDIRSUFFIX}/gcc/$TARGET/$VERSION/include
+) || exit 1
 
 ## NOTE: Thought about this, because the precompiled headers are so large.
 ## Probably easier to keep everything together, though.
@@ -570,6 +615,7 @@
 #  mv $PKG2/usr/include/c++/$VERSION/$TARGET/bits/stdc++.h.gch usr/include/c++/$VERSION/$TARGET/bits
 #)
 
+if [ `echo $addlang | grep -c 'go,'` -gt 0 ] ; then
 # gcc-go:
 ( cd $PKG8
   mkdir -p usr/bin
@@ -592,7 +638,9 @@
   mv $PKG1/usr/man/man1/go.1.gz usr/man/man1
   mv $PKG1/usr/man/man1/gofmt.1.gz usr/man/man1
 ) || exit 1
+fi
 
+if [ `echo $addlang | grep -c 'd,'` -gt 0 ] ; then
 # gcc-gdc:
 ( cd $PKG10
   mkdir -p usr/bin
@@ -615,6 +663,7 @@
   mkdir -p usr/man/man1
   mv $PKG1/usr/man/man1/gdc.1.gz usr/man/man1
 ) || exit 1
+fi
 
 # gcc-gm2:
 ( cd $PKG11
@@ -643,14 +692,20 @@
   makepkg -l y -c n $TMP/gcc-g++-$VERSION-$ARCH-$BUILD.txz )
 ( cd $PKG3
   makepkg -l y -c n $TMP/gcc-gfortran-$VERSION-$ARCH-$BUILD.txz )
+if [ `echo $addlang | grep -c 'ada,'` -gt 0 ] ; then
 ( cd $PKG4
   makepkg -l y -c n $TMP/gcc-gnat-$VERSION-$ARCH-$BUILD.txz )
+fi
 ( cd $PKG6
   makepkg -l y -c n $TMP/gcc-objc-$VERSION-$ARCH-$BUILD.txz )
+if [ `echo $addlang | grep -c 'go,'` -gt 0 ] ; then
 ( cd $PKG8
   makepkg -l y -c n $TMP/gcc-go-$VERSION-$ARCH-$BUILD.txz )
+fi
+if [ `echo $addlang | grep -c 'd,'` -gt 0 ] ; then
 ( cd $PKG10
   makepkg -l y -c n $TMP/gcc-gdc-$VERSION-$ARCH-$BUILD.txz )
+fi
 ( cd $PKG11
   makepkg -l y -c n $TMP/gcc-gm2-$VERSION-$ARCH-$BUILD.txz )
 
diff -ur slackware64-current.2/source/d/gdb/gdb.SlackBuild slackware64-current.3/source/d/gdb/gdb.SlackBuild
--- slackware64-current.2/source/d/gdb/gdb.SlackBuild	2021-09-18 13:40:05.888467298 +0200
+++ slackware64-current.3/source/d/gdb/gdb.SlackBuild	2021-09-18 13:42:53.546928934 +0200
@@ -72,6 +72,11 @@
   \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
   -exec chmod 644 {} \+
 
+if [ "$ARCH" = "mips" -o "$ARCH" = "mipsel" ] ; then
+  # Avoid overflow on simulator for MIPS32:
+  zcat $CWD/mips32_overflow.diff.gz | patch -p1 --verbose || exit 1
+fi
+
 # This has been perpetually broken, so we'll default to turning it off:
 GUILE_OPTION=${GUILE_OPTION:"--without-guile"}
 
diff -ur slackware64-current.2/source/d/guile/guile.SlackBuild slackware64-current.3/source/d/guile/guile.SlackBuild
--- slackware64-current.2/source/d/guile/guile.SlackBuild	2021-04-28 20:11:00.493022067 +0200
+++ slackware64-current.3/source/d/guile/guile.SlackBuild	2021-09-18 13:42:53.586930953 +0200
@@ -73,6 +73,9 @@
 tar xvf $CWD/guile-$VERSION.tar.?z || exit 1
 cd guile-$VERSION || exit 1
 
+# Remove 32-bit-big-endian prebuilt, since it does not work:
+rm -rf prebuilt/32-bit-big-endian
+
 chown -R root:root .
 find . \
   \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
@@ -90,6 +93,7 @@
   --disable-static \
   --disable-rpath \
   --disable-error-on-warning \
+  $EXTRAGUILE \
   --build=$ARCH-slackware-linux || exit 1
 
 # Does not like parallel make...
diff -ur slackware64-current.2/source/d/libgccjit/libgccjit.SlackBuild slackware64-current.3/source/d/libgccjit/libgccjit.SlackBuild
--- slackware64-current.2/source/d/libgccjit/libgccjit.SlackBuild	2024-02-13 22:27:32.208514310 +0100
+++ slackware64-current.3/source/d/libgccjit/libgccjit.SlackBuild.new	2024-02-13 23:36:51.525931524 +0100
@@ -150,14 +149,30 @@
 ( mkdir gcc.build.lnx
   cd gcc.build.lnx
 
-  if [ "$ARCH" != "x86_64" ]; then
+  if [ "$ARCH" == "armv7hl" ]; then
+    GCC_ARCHOPTS="--with-tune=cortex-a8 --with-arch=armv7-a --with-float=hard --with-fpu=vfpv3-d16 --with-abi=aapcs-linux"
+  elif [ "$ARCH" == "arm" ]; then
+    GCC_ARCHOPTS="--with-arch=armv5te --with-float=soft"
+  elif [ "$ARCH" == "aarch64" ]; then
+    GCC_ARCHOPTS="--with-arch=armv8-a"
+  elif [ "$ARCH" == "mips" ]; then
+    GCC_ARCHOPTS="--with-arch=mips32r2"
+  elif [ "$ARCH" == "mipsel" ]; then
+    GCC_ARCHOPTS="--with-arch=mips32r2"
+  elif [ "$ARCH" == "mips64el" ]; then
+    GCC_ARCHOPTS="--with-arch=mips64r2 --disable-multilib"
+  elif [ "$ARCH" == "sparc" ]; then
+    GCC_ARCHOPTS="--with-cpu=leon3 --with-float=hard --disable-multilib --disable-libitm"
+  elif [ "$ARCH" == "sparc64" ]; then
+    GCC_ARCHOPTS="--with-cpu=ultrasparc --with-float=hard --disable-multilib"
+  elif [ `echo "$ARCH" | grep -cE '^i.86$'` -gt 0 ]; then
     GCC_ARCHOPTS="--with-arch=$ARCH"
   else
     GCC_ARCHOPTS="--disable-multilib"
   fi
 
-  CFLAGS="$SLKCFLAGS" \
-  CXXFLAGS="$SLKCFLAGS" \
+  CFLAGS="$SLKCFLAGS -D_DONOTFORCE_TIME_BITS" \
+  CXXFLAGS="$SLKCFLAGS -D_DONOTFORCE_TIME_BITS" \
   ../configure --prefix=/usr \
      --libdir=/usr/lib$LIBDIRSUFFIX \
      --mandir=/usr/man \
diff -ur slackware64-current.2/source/d/llvm/llvm.SlackBuild slackware64-current.3/source/d/llvm/llvm.SlackBuild
--- slackware64-current.2/source/d/llvm/llvm.SlackBuild	2023-09-24 20:35:11.100136347 +0200
+++ slackware64-current.3/source/d/llvm/llvm.SlackBuild	2023-09-30 09:57:58.045992151 +0200
@@ -67,6 +67,8 @@
 # massive warning spew:
 IGNORE_GNU_EXTENSIONS=${IGNORE_GNU_EXTENSIONS:--Wno-unknown-warning-option -Wno-gnu-line-marker -Wno-gnu-anonymous-struct -Wno-gnu-include-next}
 
+LINKER="lld"
+
 if [ "$ARCH" = "i586" ]; then
   SLKCFLAGS="-O2 -march=i586 -mtune=i686 $IGNORE_GNU_EXTENSIONS"
   LIBDIRSUFFIX=""
@@ -94,6 +96,54 @@
   CLANGD="-DCLANG_ENABLE_CLANGD=OFF"
 fi
 
+# Building lld will be determined automatically unless BUILD_LLD is
+# preset to YES or NO:
+if [ -z $BUILD_LLD ]; then
+  if [ "$ARCH" =  "or1k" -o "$ARCH" = "sh4" -o "$ARCH" = "alpha" -o "$ARCH" = "hppa" ]; then
+    BUILD_LLD=NO
+  else
+    BUILD_LLD=YES
+  fi
+fi
+
+# Building lldb will be determined automatically unless BUILD_LLDB is
+# preset to YES or NO:
+if [ -z $BUILD_LLDB ]; then
+  if [ "$ARCH" = "riscv64" -o "$ARCH" = "ppc" -o "${ARCH::4}" = "mips"  -o "$ARCH" =  "or1k" -o "$ARCH" = "sh4" -o "$ARCH" = "alpha" -o "$ARCH" = "hppa" -o "${ARCH::5}" = "sparc" ]; then
+    BUILD_LLDB=NO
+  else
+    BUILD_LLDB=YES
+  fi
+fi
+
+# Building OpenMP will be determined automatically unless BUILD_OPENMP is
+# preset to YES or NO:
+if [ -z $BUILD_OPENMP ]; then
+  if [ "$ARCH" = "ppc" -o "$ARCH" = "mips" -o "$ARCH" = "mipsel" -o "$ARCH" = "riscv64" -o "$ARCH" = "s390x" -o "$ARCH" =  "or1k" -o "$ARCH" = "sh4" -o "$ARCH" = "alpha" -o "$ARCH" = "hppa" -o "${ARCH::5}" = "sparc" ]; then
+    # OpenMP not supported on PowerPC 32 bits / RISC-V / zArchitecture
+    BUILD_OPENMP=NO
+  else
+    BUILD_OPENMP=YES
+  fi
+fi
+
+# Building Host clang will be determined automatically unless BUILD_HOST is
+# preset to YES or NO:
+if [ -z $BUILD_HOST ]; then
+  if [ "$ARCH" = "sh4" -o "$ARCH" = "or1k" -o "$ARCH" = "hppa" -o "$ARCH" = "alpha" ]; then
+    # clang not supported on sh4, or1k, hppa, alpha
+    BUILD_HOST=NO
+  else
+    BUILD_HOST=YES
+  fi
+fi
+
+if [ "$BUILD_HOST" = "YES" ]; then
+  ADD_HOST="host;"
+else
+  ADD_HOST=""
+fi
+
 # Python3 short version:
 PY3=$(python3 -c 'from distutils.sysconfig import get_python_lib; print(get_python_lib())' | cut -f 2 -d n | cut -f 1 -d /)
 
@@ -130,12 +180,16 @@
   #echo "Extracting $CWD/flang-$VERSION.src.tar.xz..."
   #tar xf $CWD/flang-$VERSION.src.tar.xz || exit 1
   #mv flang-${VERSION} flang 2>/dev/null || mv flang-${VERSION}.src flang || exit 1
-  echo "Extracting $CWD/lldb-$VERSION.src.tar.xz..."
-  tar xf $CWD/lldb-$VERSION.src.tar.xz || exit 1
-  mv lldb-${VERSION} lldb 2>/dev/null || mv lldb-${VERSION}.src lldb || exit 1
-  echo "Extracting $CWD/lld-$VERSION.src.tar.xz..."
-  tar xf $CWD/lld-$VERSION.src.tar.xz || exit 1
-  mv lld-${VERSION} lld 2>/dev/null || mv lld-${VERSION}.src lld || exit 1
+  if [ "$BUILD_LLDB" = "YES" ]; then
+    echo "Extracting $CWD/lldb-$VERSION.src.tar.xz..."
+    tar xf $CWD/lldb-$VERSION.src.tar.xz || exit 1
+    mv lldb-${VERSION} lldb 2>/dev/null || mv lldb-${VERSION}.src lldb || exit 1
+  fi
+  if [ "$BUILD_LLD" = "YES" ]; then
+    echo "Extracting $CWD/lld-$VERSION.src.tar.xz..."
+    tar xf $CWD/lld-$VERSION.src.tar.xz || exit 1
+    mv lld-${VERSION} lld 2>/dev/null || mv lld-${VERSION}.src lld || exit 1
+  fi
 cd ../
 
 cd tools/clang/tools || exit 1
@@ -149,9 +203,13 @@
   echo "Extracting $CWD/compiler-rt-$VERSION.src.tar.xz..."
   tar xf $CWD/compiler-rt-$VERSION.src.tar.xz || exit 1
   mv compiler-rt-${VERSION} compiler-rt 2>/dev/null || mv compiler-rt-${VERSION}.src compiler-rt || exit 1
-  echo "Extracting $CWD/openmp-$VERSION.src.tar.xz..."
-  tar xf $CWD/openmp-$VERSION.src.tar.xz || exit 1
-  mv openmp-${VERSION} openmp 2>/dev/null || mv openmp-${VERSION}.src openmp || exit 1
+  # Fixing "asan_interceptors.cpp:(.text+0x450): relocation truncated to fit: R_MIPS_PC16 against `__interceptor_inet_pton'":
+  zcat $CWD/mips_sanitizer_R_MIPS_PC16.diff.gz | patch -p1 --verbose || exit 1
+  if [ "$BUILD_OPENMP" = "YES" ]; then
+    echo "Extracting $CWD/openmp-$VERSION.src.tar.xz..."
+    tar xf $CWD/openmp-$VERSION.src.tar.xz || exit 1
+    mv openmp-${VERSION} openmp 2>/dev/null || mv openmp-${VERSION}.src openmp || exit 1
+  fi
   echo "Extracting $CWD/libcxx-${VERSION}.src.tar.xz..."
   tar xf $CWD/libcxx-${VERSION}.src.tar.xz || exit 1
   mv libcxx-${VERSION} libcxx 2>/dev/null || mv libcxx-${VERSION}.src libcxx || exit 1
@@ -185,6 +243,37 @@
 ln -sf ../../cmake .
 cd -
 
+# Patch arm: soft float, invalid conversion from unwind state:
+zcat $CWD/arm_soft.diff.gz | patch -p1 --verbose || exit 1
+zcat $CWD/unwind_state_invalid_conversion.diff.gz | patch -p1 --verbose || exit 1
+
+if [ "${ARCH::3}" = "arm" ]; then
+  # Re-enabling system libunwind, since it searches for aeabi_unwind* function that are
+  # not present in bundled one
+  zcat $CWD/arm_enable_system_libunwind.diff.gz | patch -p1 --verbose || exit 1
+fi
+
+if [ "$ARCH" = "mips" -o "$ARCH" = "mipsel" ]; then
+  # Disabling FLOAT16, since it requires mips64 instructions
+  zcat $CWD/mips_disable_float16.diff.gz | patch -p1 --verbose || exit 1
+fi
+
+if [ "$BUILD_HOST" = "NO" ]; then
+  # Disabling arch/triple autodetection, since it does not work without host target
+  zcat $CWD/disable_default_arch_detect.diff.gz | patch -p1 --verbose || exit 1
+fi
+
+# Patch riscv64: AllWinner D1 does not have fence.tso instruction:
+zcat $CWD/riscv64-no-fence.tso.diff.gz | patch -p1 --verbose || exit 1
+
+# Patch alpha: Fix invalid variable name __alpha:
+zcat $CWD/alpha_fix_variable_name.diff.gz | patch -p1 --verbose || exit 1
+
+# Add new architectures (loongarch64, or1k, etc...) to cmake config.guess and config-ix.cmake:
+\cp /usr/share/libtool/build-aux/config.* cmake/
+zcat $CWD/newarchs.diff.gz | patch -p1 --verbose || exit 1
+
+
 chown -R root:root .
 find . \
   \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 -o -perm 511 \) \
@@ -201,6 +290,21 @@
   SHARED_LIBRARY_OPTIONS="-DLLVM_BUILD_LLVM_DYLIB=ON -DLLVM_LINK_LLVM_DYLIB=ON -DCLANG_LINK_CLANG_DYLIB=ON"
 fi
 
+# In bootstrap system, or for architectures that does not support host llvm,
+# clang is not yet available or it could not compile c(++) sources, use gcc
+which clang 2> /dev/null
+if [ $? -eq 0 -a `file -L $(which clang) | grep -c 'shell script'` -eq 0 ]
+then
+  C_COMPILER="clang"
+  CXX_COMPILER="clang++"
+else
+  C_COMPILER="gcc"
+  CXX_COMPILER="g++"
+  LINKER="bfd"
+fi
+
+SLKCFLAGS="$SLKCFLAGS $IGNORE_GNU_EXTENSIONS"
+
 mkdir build
 cd build
   mkdir include
@@ -209,8 +313,8 @@
   # Nuke LLVM libunwind as it conflicts with the one already on the system:
   rm -r ../projects/libunwind
   cmake -GNinja \
-    -DCMAKE_C_COMPILER="clang" \
-    -DCMAKE_CXX_COMPILER="clang++" \
+    -DCMAKE_C_COMPILER="$C_COMPILER" \
+    -DCMAKE_CXX_COMPILER="$CXX_COMPILER" \
     -DCMAKE_C_FLAGS:STRING="$SLKCFLAGS" \
     -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS" \
     -DCMAKE_INSTALL_PREFIX=/usr \
@@ -219,7 +323,7 @@
     -DLIBCXXABI_LIBDIR_SUFFIX=${LIBDIRSUFFIX} \
     -DCMAKE_BUILD_TYPE=Release \
     $SHARED_LIBRARY_OPTIONS \
-    -DLLVM_USE_LINKER=lld \
+    -DLLVM_USE_LINKER=$LINKER \
     -DLLVM_ENABLE_RTTI=ON \
     -DLLVM_ENABLE_FFI=ON \
     -DLLVM_ENABLE_ZLIB=ON \
@@ -228,7 +332,8 @@
     -DLLVM_INSTALL_UTILS=ON \
     -DLLVM_BINUTILS_INCDIR=/usr/include \
     -DCLANG_RESOURCE_DIR="../lib${LIBDIRSUFFIX}/clang/$(echo $VERSION | cut -f 1 -d .)" \
-    -DLLVM_TARGETS_TO_BUILD="host;AMDGPU;BPF" \
+    -DLLVM_TARGETS_TO_BUILD="${ADD_HOST}AMDGPU;BPF" \
+    $CMAKE_EXTRA \
     -DLLVM_INCLUDE_BENCHMARKS=OFF \
     -DLIBCXX_INCLUDE_BENCHMARKS=OFF \
     -DCOMPILER_RT_BUILD_LIBFUZZER=OFF \
@@ -242,12 +347,29 @@
   DESTDIR=$PKG "$NINJA" install || exit 1
 cd ..
 
+case "$ARCH" in
+  arm) TARGET=$ARCH-slackware-linux-gnueabi ;;
+  armv7hl) TARGET=$ARCH-slackware-linux-gnueabihf ;;
+  mips64el) TARGET=$ARCH-slackware-linux-gnueabi64 ;;
+     *) TARGET=$ARCH-slackware-linux ;;
+esac
+
 # Add symlinks for $ARCH-slackware-linux-{clang,clang++}:
 ( cd $PKG/usr/bin
-  ln -sf clang $ARCH-slackware-linux-clang
-  ln -sf clang++ $ARCH-slackware-linux-clang++
+  ln -sf clang $TARGET-clang
+  ln -sf clang++ $TARGET-clang++
 )
 
+# Add clang target if host clang not built:
+if [ "$BUILD_HOST" = "NO" ]; then
+( cd $PKG/usr/bin
+  SHORTVER=`echo clang-[0-9][0-9] | sed 's/clang-//'`
+  mv clang-$SHORTVER clang-$SHORTVER.orig
+  cat $CWD/clang.target | sed "s/-XX/-$SHORTVER/g" > clang-$SHORTVER
+  chmod 755 clang-$SHORTVER
+)
+fi
+
 # Install clang-static-analyzer:
 for i in ccc c++; do
   ln -s /usr/libexec/$i-analyzer \
diff -ur slackware64-current.2/source/d/m4/m4.SlackBuild slackware64-current.3/source/d/m4/m4.SlackBuild
--- slackware64-current.2/source/d/m4/m4.SlackBuild	2021-05-31 21:24:21.170031455 +0200
+++ slackware64-current.3/source/d/m4/m4.SlackBuild	2023-06-15 09:15:36.667957641 +0200
@@ -81,6 +81,9 @@
   \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
   -exec chmod 644 {} \+
 
+# Disabled SPARCv8plus instructions (-mcpu=v9):
+sed -i 's/ -mcpu=v9//' configure
+
 CFLAGS="$SLKCFLAGS" \
 ./configure \
   --prefix=/usr \
diff -ur slackware64-current.2/source/d/meson/meson.SlackBuild slackware64-current.3/source/d/meson/meson.SlackBuild
--- slackware64-current.2/source/d/meson/meson.SlackBuild	2021-06-08 22:36:48.082202988 +0200
+++ slackware64-current.3/source/d/meson/meson.SlackBuild	2021-09-18 13:42:53.796941553 +0200
@@ -65,6 +65,16 @@
  \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
   -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \+
 
+# Meson check only if the compiler supports NEON instructions without
+# checking if CAN compile NEON instructions with selected architecture.
+# Disabling simd-neon for ARMv5 ("arm" ARCH):
+if [ "$ARCH" = "arm" ]; then
+  zcat $CWD/disabling_neon_armv5.diff.gz | patch -p1 --verbose || exit 1
+fi
+
+# Adding new architectures (openrisc):
+zcat $CWD/new_architectures.diff.gz | patch -p1 --verbose || exit 1
+
 python3 setup.py install --root=$PKG || exit 1
 
 mv $PKG/usr/share/man $PKG/usr/
diff -ur slackware64-current.2/source/d/oprofile/oprofile.SlackBuild slackware64-current.3/source/d/oprofile/oprofile.SlackBuild
--- slackware64-current.2/source/d/oprofile/oprofile.SlackBuild	2021-08-28 21:45:51.897177190 +0200
+++ slackware64-current.3/source/d/oprofile/oprofile.SlackBuild	2021-09-18 13:42:53.846944077 +0200
@@ -82,6 +82,11 @@
   \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
   -exec chmod 644 {} \+
 
+# Disabling PFMLIB for powerpc platform:
+zcat $CWD/disable_pfm.patch.gz | patch -p1 --verbose || exit 1
+# Adding rmb definition for riscv:
+zcat $CWD/riscv_rmb_definition.diff.gz | patch -p1 --verbose || exit 1
+
 CFLAGS="$SLKCFLAGS" \
 CXXFLAGS="$SLKCFLAGS" \
 ./configure \
diff -ur slackware64-current.2/source/d/perl/perl.SlackBuild slackware64-current.3/source/d/perl/perl.SlackBuild
--- slackware64-current.2/source/d/perl/perl.SlackBuild	2021-05-21 06:51:21.743866987 +0200
+++ slackware64-current.3/source/d/perl/perl.SlackBuild	2021-09-18 13:42:53.956949629 +0200
@@ -146,7 +146,7 @@
 #
 USE_THREADS="-Dusethreads -Duseithreads"
 
-if [ "$ARCH" = "x86_64" ]; then # adopted from "Cross Linux From Scratch"
+if [ "$LIBDIRSUFFIX" = "64" ]; then # adopted from "Cross Linux From Scratch"
   # Configure must be told to also use lib64:
   zcat $CWD/perl.configure.multilib.patch.gz | patch -p1 --verbose || exit 1
   # "perl -V" should report that libc is in /lib64
diff -ur slackware64-current.2/source/d/poke/poke.SlackBuild slackware64-current.3/source/d/poke/poke.SlackBuild
--- slackware64-current.2/source/d/poke/poke.SlackBuild	2022-01-31 09:45:37.918393279 +0100
+++ slackware64-current.3/source/d/poke/poke.SlackBuild	2023-07-07 15:32:31.178365617 +0200
@@ -86,6 +86,9 @@
 tar xvf $CWD/$PKGNAM-$VERSION.tar.?z || exit 1
 cd $PKGNAM-$VERSION || exit 1
 
+# Disable v9-assembly for sparc32:
+zcat $CWD/jitter_disable_assembly_for_sparc32.diff.gz | patch -p1 --verbose || exit 1
+
 chown -R root:root .
 find . \
   \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
diff -ur slackware64-current.2/source/d/python2/python2.SlackBuild slackware64-current.3/source/d/python2/python2.SlackBuild
--- slackware64-current.2/source/d/python2/python2.SlackBuild	2021-02-13 06:31:55.408945438 +0100
+++ slackware64-current.3/source/d/python2/python2.SlackBuild	2021-09-18 13:42:54.126958210 +0200
@@ -81,12 +81,15 @@
 # We don't want a large libpython*.a:
 zcat $CWD/python.no-static-library.diff.gz | patch -p1 --verbose || exit 1
 
-if [ "$ARCH" = "x86_64" ]; then
+if [ "$LIBDIRSUFFIX" = "64" ]; then
   # Install to lib64 instead of lib and 
   # Python must report /usr/lib64/python2.7/site-packages as python_lib_dir:
   zcat $CWD/python.x86_64.diff.gz | patch -p1 --verbose || exit 1
 fi
 
+# Add _ctypes support for MIPS64
+zcat $CWD/python.mips64-missing-n32-functions.diff.gz | patch -p1 --verbose || exit 1
+
 chown -R root:root .
 find . \
  \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
diff -ur slackware64-current.2/source/d/rust/rust.SlackBuild slackware64-current.3/source/d/rust/rust.SlackBuild
--- slackware64-current.2/source/d/rust/rust.SlackBuild	2021-09-09 19:19:52.527012986 +0200
+++ slackware64-current.3/source/d/rust/rust.SlackBuild	2021-09-18 13:42:54.186961238 +0200
@@ -67,10 +67,14 @@
 
 # If the bootstrap binaries are present, use those. Otherwise bootstrap from
 # installed compiler.
-if /bin/ls *-unknown-linux-gnu.tar.?z 1> /dev/null 2> /dev/null ; then
+if /bin/ls *-unknown-linux-gnu*.tar.?z 1> /dev/null 2> /dev/null ; then
   LOCAL_BOOTSTRAP=no
 else
-  LOCAL_BOOTSTRAP=yes
+  if [ "$LOCAL_BOOTSTRAP" = "" ] && [ -x /usr/bin/cargo ] && [ -x /usr/bin/rustc ] ; then
+    LOCAL_BOOTSTRAP=yes
+  else
+    LOCAL_BOOTSTRAP=no
+  fi
 fi
 
 # https://forge.rust-lang.org/platform-support.html
@@ -98,6 +102,21 @@
 elif [ "$ARCH" = "armv7hl" ]; then
   BARCH="armv7"
   TARCH="$BARCH"
+elif [ "$ARCH" = "arm" ]; then
+  BARCH="armv5te"
+  TARCH="$BARCH"
+elif [ "$ARCH" = "ppc" ]; then
+  BARCH="powerpc"
+  TARCH="$BARCH"
+elif [ "$ARCH" = "ppc64" ]; then
+  BARCH="powerpc64"
+  TARCH="$BARCH"
+elif [ "$ARCH" = "ppc64le" ]; then
+  BARCH="powerpc64le"
+  TARCH="$BARCH"
+elif [ "$ARCH" = "riscv64" ]; then
+  BARCH="riscv64gc"
+  TARCH="$BARCH"
 else
   BARCH="$ARCH"
   TARCH="$ARCH"
@@ -106,6 +125,10 @@
 # Bootstrapping ABI:
 if [ "$ARCH" = "armv7hl" ]; then
   BABI="gnueabihf"
+elif [ "$ARCH" = "arm" ]; then
+  BABI="gnueabi"
+elif [ "$ARCH" = "mips64el" ]; then
+  BABI="gnuabi64"
 else
   BABI="gnu"
 fi
@@ -142,15 +165,27 @@
   zcat $CWD/link_libffi.diff.gz | patch -p1 --verbose || exit 1
 fi
 
+# Patch armv5te atomic operations (already defined in libgcc) and rls AtomicU64
+if [ "${ARCH}" = "arm" ]; then
+  ckorig=`sha256sum vendor/compiler_builtins/src/arm_linux.rs | cut -f1 -d' '`
+  zcat $CWD/atomic_builtins_gcc9.diff.gz | patch -p1 --verbose || exit 1
+  cknew=`sha256sum vendor/compiler_builtins/src/arm_linux.rs | cut -f1 -d' '`
+  # Fix cargo checksum for above patch
+  sed -i "s/$ckorig/$cknew/" vendor/compiler_builtins/.cargo-checksum.json
+fi
+
+# Fix GOT overflow on bootstrap for mips64el:
+zcat $CWD/d-fix-mips64el-bootstrap.diff.gz | patch -p1 --verbose || exit 1
+
 if [ "$LOCAL_BOOTSTRAP" != "yes" ] ; then
   # rust requires bootstrapping with the previous rust version.
   # versions are defined in src/stage0.txt.
   mkdir -p build/cache/$RSTAGE0_DIR
-  cp $CWD/$PKGNAM-std-$RSTAGE0_VERSION-$BARCH-unknown-linux-gnu.tar.?z \
-     $CWD/$SRCNAM-$RSTAGE0_VERSION-$BARCH-unknown-linux-gnu.tar.?z \
+  cp $CWD/$PKGNAM-std-$RSTAGE0_VERSION-$BARCH-unknown-linux-gnu*.tar.?z \
+     $CWD/$SRCNAM-$RSTAGE0_VERSION-$BARCH-unknown-linux-gnu*.tar.?z \
      build/cache/$RSTAGE0_DIR
   mkdir -p build/cache/$CSTAGE0_DIR
-  cp $CWD/cargo-$CSTAGE0_VERSION-$BARCH-unknown-linux-gnu.tar.?z build/cache/$CSTAGE0_DIR
+  cp $CWD/cargo-$CSTAGE0_VERSION-$BARCH-unknown-linux-gnu*.tar.?z build/cache/$CSTAGE0_DIR
 fi
 
 # Build configuration:
@@ -195,8 +234,45 @@
 [target.x86_64-unknown-linux-gnu]
 llvm-config = "/usr/bin/llvm-config"
 
+[target.arm-unknown-linux-gnueabi]
+llvm-config = "/usr/bin/llvm-config"
+
+[target.armv5te-unknown-linux-gnueabi]
+llvm-config = "/usr/bin/llvm-config"
+
 [target.armv7-unknown-linux-gnueabihf]
 llvm-config = "/usr/bin/llvm-config"
+
+[target.aarch64-unknown-linux-gnu]
+llvm-config = "/usr/bin/llvm-config"
+
+[target.powerpc-unknown-linux-gnu]
+llvm-config = "/usr/bin/llvm-config"
+
+[target.powerpc64-unknown-linux-gnu]
+llvm-config = "/usr/bin/llvm-config"
+
+[target.powerpc64le-unknown-linux-gnu]
+llvm-config = "/usr/bin/llvm-config"
+
+[target.mips-unknown-linux-gnu]
+llvm-config = "/usr/bin/llvm-config"
+
+[target.mipsel-unknown-linux-gnu]
+llvm-config = "/usr/bin/llvm-config"
+
+[target.mips64el-unknown-linux-gnuabi64]
+llvm-config = "/usr/bin/llvm-config"
+
+[target.riscv64gc-unknown-linux-gnu]
+llvm-config = "/usr/bin/llvm-config"
+
+[target.s390x-unknown-linux-gnu]
+llvm-config = "/usr/bin/llvm-config"
+
+[target.loongarch64-unknown-linux-gnu]
+llvm-config = "/usr/bin/llvm-config"
+
 EOF
 fi
 
@@ -258,7 +328,7 @@
 
 # Evidently there are a lot of duplicated libraries in this tree, so let's
 # try to save some space:
-( cd $PKG/usr/lib${LIBDIRSUFFIX}/rustlib/*-linux-gnu/lib && for file in *.so ; do if cmp -s $file ../../../$file ; then ln -sf ../../../$file .; fi; done )
+( cd $PKG/usr/lib${LIBDIRSUFFIX}/rustlib/*-linux-gnu*/lib && for file in *.so ; do if cmp -s $file ../../../$file ; then ln -sf ../../../$file .; fi; done )
 
 # Strip ELF objects:
 find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
diff -ur slackware64-current.2/source/d/rust-bindgen/rust-bindgen.SlackBuild slackware64-current.3/source/d/rust-bindgen/rust-bindgen.SlackBuild
--- slackware64-current.2/source/d/rust-bindgen/rust-bindgen.SlackBuild	2021-09-09 19:19:52.527012986 +0200
+++ slackware64-current.3/source/d/rust-bindgen/rust-bindgen.SlackBuild	2021-09-18 13:42:54.186961238 +0200
@@ -98,6 +98,37 @@
 directory = "vendor"
 EOF
 
+# rustix uses now by default linux_raw backend for syscalls, but seems supported only
+# for aarch64, arm, mipsel, mips64el, powerpc64le, riscv64, x86, and x86_64.
+# Re-add real errno for other architectures, or you can pass "--cfg=rustix_use_libc" 
+# to force libc usage.
+case "$ARCH" in
+  mips|ppc|ppc64|s390x|loongarch64) 
+    (cd vendor
+     rm -rf errno
+     tar xvf $CWD/errno-*.tar.lz
+     for r in rustix*
+     do
+       (cd $r
+       perl -n -e '
+	 if(m/dependencies.libc_errno/) { $status=1; }
+	 if($status && m/"0.3.[012]"/) {
+	   s/"0.3.[012]"/"0.3.3"/;
+	   $status=0;
+	 }
+	 print;
+       ' Cargo.toml > Cargo.toml.tmp
+       \mv Cargo.toml.tmp Cargo.toml
+       cat .cargo-checksum.json  | perl -e '($newck)=split(" ",$ARGV[0]);while(<STDIN>) { s/("Cargo.toml":)"(\S+?)"/$1"$newck"/; print;}' `sha256sum Cargo.toml` > .cargo-checksum.json.tmp
+       \mv .cargo-checksum.json.tmp .cargo-checksum.json
+       )
+     done
+    )
+    #SLKRUSTFLAGS="--cfg=rustix_use_libc"
+    ;;
+esac
+
+RUSTFLAGS="$SLKRUSTFLAGS" \
 CFLAGS="$SLKCFLAGS" \
 CXXFLAGS="$SLKCFLAGS" \
 RUSTONIG_DYNAMIC_LIBONIG=1 \
@@ -104,13 +104,12 @@
 cargo build \
   --offline \
   --release \
-  --target $ARCH-unknown-linux-gnu \
   --verbose \
   $NUMJOBS || exit 1
 
 mkdir -p $PKG/usr/bin
-install -m 755 target/$ARCH-unknown-linux-gnu/release/bindgen \
-  $PKG/usr/bin/
+install -m 755 target/release/bindgen \
+  $PKG/usr/bin/ || exit 1
 
 find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
   | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
diff -ur slackware64-current/source/d/slacktrack/slacktrack.SlackBuild slackware64-current.2/source/d/slacktrack/slacktrack.SlackBuild
--- slackware64-current/source/d/slacktrack/slacktrack.SlackBuild	2021-08-12 15:41:16.000000000 +0200
+++ slackware64-current.2/source/d/slacktrack/slacktrack.SlackBuild	2021-09-18 13:41:20.862251020 +0200
@@ -8,6 +8,7 @@
 PKGNAM=slacktrack
 export VERSION=2.21
 # Automatically determine the architecture we're building on:
+if [ -z "$ARCH" ]; then
 case "$( uname -m )" in
   i?86)    export ARCH=i586
            PKGEXT=txz ;;
@@ -17,6 +18,7 @@
      *)    export ARCH=$( uname -m )
            PKGEXT=txz ;;
 esac
+fi
 BUILD=${BUILD:-1}
 export BUILD
 
@@ -36,5 +38,8 @@
 tar xvf $CWD/slacktrack-$VERSION-source.tar.xz
 cd slacktrack-project || exit 1
 
+# Fix incorrect ARCH assignment if already set
+zcat $CWD/fix_already_set_arch.patch.gz | patch -p1
+
 # Start the "real" SlackBuild:
 ./slacktrack.SlackBuild
